function bars = GenerateRandomBars(o,h,l,c,n)

pnls = (c - backshift(1, c))./backshift(1, c);
[x,y] = hist(pnls,1000);
rc = GenerateRandomWalk(y,x,n);
rc = cumprod(1+rc);

gaps = (o - backshift(1,c)) ./ c;
[x,y] = hist(gaps,1000);
rgaps = GenerateRandomWalk(y,x,n);
ro = nan(n,1);
ro(1) = rc(1);
ro(2:end) = rc(1:end-1) + rgaps(1:end-1) .* rc(1:end-1);

range = (h - l) ./ c;
[x,y] = hist(range,1000);
rrange = GenerateRandomWalk(y,x,n);
rrange = rrange .* rc;
rands = rand(n,1);
rh = rc + rands .* rrange;
rl = rc - (1-rands) .* rrange;

for i = 1:n
    
    if ro(i) > rh(i)
        ro(i) = rh(i);
    elseif ro(i) < rl(i)
        ro(i) = rl(i);
    end
    
end

bars = struct('o', ro, 'h', rh, 'l', rl, 'c', rc);











